<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLContainersSubgraphBase&lt; CVertex &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classSubgraphBase-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLContainersSubgraphBase&lt; CVertex &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__data__structures.html">Data Structures</a> &#124; <a class="el" href="group__containers.html">Graph Containers</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>core data container for a subgraph in each device.  
 <a href="classSubgraphBase.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglContainersSubgraphBase_8hpp_source.html">tiglContainersSubgraphBase.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for TIGLContainersSubgraphBase&lt; CVertex &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classSubgraphBase.png" usemap="#TIGLContainersSubgraphBase&lt; CVertex &gt;_map" alt=""/>
  <map id="TIGLContainersSubgraphBase&lt; CVertex &gt;_map" name="TIGLContainersSubgraphBase&lt; CVertex &gt;_map">
<area href="classSubgraph.html" title="Graph container for each device in TIGL. " alt="TIGLContainersSubgraph&lt; CVertex, MessageType &gt;" shape="rect" coords="0,56,225,80"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a9a38e2aef24edfb18f95685e88441c15"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a9a38e2aef24edfb18f95685e88441c15">TIGLContainersSubgraphBase</a> (bool isDireted=true, ID_TYPE assignedHashSize=0)</td></tr>
<tr class="memdesc:a9a38e2aef24edfb18f95685e88441c15"><td class="mdescLeft">&#160;</td><td class="mdescRight">constructor of <a class="el" href="classSubgraphBase.html" title="core data container for a subgraph in each device. ">TIGLContainersSubgraphBase</a>  <a href="#a9a38e2aef24edfb18f95685e88441c15">More...</a><br /></td></tr>
<tr class="separator:a9a38e2aef24edfb18f95685e88441c15"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a401d397bc80d0c0606056ab1ff00e1ef"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a401d397bc80d0c0606056ab1ff00e1ef">TIGLContainersSubgraphBase</a> (VERTEX_LIST_TYPE &amp;init_adj_list, bool isDireted, ID_TYPE assignedHashSize=0)</td></tr>
<tr class="memdesc:a401d397bc80d0c0606056ab1ff00e1ef"><td class="mdescLeft">&#160;</td><td class="mdescRight">overloaded constructor of <a class="el" href="classSubgraphBase.html" title="core data container for a subgraph in each device. ">TIGLContainersSubgraphBase</a>  <a href="#a401d397bc80d0c0606056ab1ff00e1ef">More...</a><br /></td></tr>
<tr class="separator:a401d397bc80d0c0606056ab1ff00e1ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ded8c3cbfaa063fdf16cb25ab2b0399"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a5ded8c3cbfaa063fdf16cb25ab2b0399">exist</a> (ID_TYPE id)</td></tr>
<tr class="memdesc:a5ded8c3cbfaa063fdf16cb25ab2b0399"><td class="mdescLeft">&#160;</td><td class="mdescRight">check the existence of a vertex  <a href="#a5ded8c3cbfaa063fdf16cb25ab2b0399">More...</a><br /></td></tr>
<tr class="separator:a5ded8c3cbfaa063fdf16cb25ab2b0399"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7769955c76112efe2c23ef43a85ac552"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7769955c76112efe2c23ef43a85ac552"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a7769955c76112efe2c23ef43a85ac552">reset</a> ()</td></tr>
<tr class="memdesc:a7769955c76112efe2c23ef43a85ac552"><td class="mdescLeft">&#160;</td><td class="mdescRight">initialization procedure <br /></td></tr>
<tr class="separator:a7769955c76112efe2c23ef43a85ac552"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad588a2ada1c05c5a91f8127a5cb7e700"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#ad588a2ada1c05c5a91f8127a5cb7e700">findPos</a> (ID_TYPE &amp;id, uint_fast32_t &amp;pos)</td></tr>
<tr class="memdesc:ad588a2ada1c05c5a91f8127a5cb7e700"><td class="mdescLeft">&#160;</td><td class="mdescRight">finding the position of a given vertex (from its id)  <a href="#ad588a2ada1c05c5a91f8127a5cb7e700">More...</a><br /></td></tr>
<tr class="separator:ad588a2ada1c05c5a91f8127a5cb7e700"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f84979500a707a643c5bd1638ec6f67"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a7f84979500a707a643c5bd1638ec6f67">addVertex</a> (<a class="el" href="classVertexBase.html">CVertex</a> &amp;x)</td></tr>
<tr class="memdesc:a7f84979500a707a643c5bd1638ec6f67"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding a single vertex to the vertex list  <a href="#a7f84979500a707a643c5bd1638ec6f67">More...</a><br /></td></tr>
<tr class="separator:a7f84979500a707a643c5bd1638ec6f67"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1d321bddac759f440f3292081b89a82"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#af1d321bddac759f440f3292081b89a82">createVerticesList</a> (ID_TYPE &amp;numVertices)</td></tr>
<tr class="memdesc:af1d321bddac759f440f3292081b89a82"><td class="mdescLeft">&#160;</td><td class="mdescRight">creating vertex list with trivial vertices  <a href="#af1d321bddac759f440f3292081b89a82">More...</a><br /></td></tr>
<tr class="separator:af1d321bddac759f440f3292081b89a82"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aafd0e90c37dae7b49cbdc612362df8d0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#aafd0e90c37dae7b49cbdc612362df8d0">addVertex</a> (ID_TYPE &amp;id)</td></tr>
<tr class="memdesc:aafd0e90c37dae7b49cbdc612362df8d0"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding an empty vertex (by id)  <a href="#aafd0e90c37dae7b49cbdc612362df8d0">More...</a><br /></td></tr>
<tr class="separator:aafd0e90c37dae7b49cbdc612362df8d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1a8f8c5aebe53cfa75a0da8ceeb13c73"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a1a8f8c5aebe53cfa75a0da8ceeb13c73">addVertex_consistent</a> (<a class="el" href="classVertexBase.html">CVertex</a> &amp;x)</td></tr>
<tr class="memdesc:a1a8f8c5aebe53cfa75a0da8ceeb13c73"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding a single vertex after checking its existence  <a href="#a1a8f8c5aebe53cfa75a0da8ceeb13c73">More...</a><br /></td></tr>
<tr class="separator:a1a8f8c5aebe53cfa75a0da8ceeb13c73"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a690892609f9fe96c720b12364b522f05"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a690892609f9fe96c720b12364b522f05">removeVertex</a> (ID_TYPE &amp;id)</td></tr>
<tr class="memdesc:a690892609f9fe96c720b12364b522f05"><td class="mdescLeft">&#160;</td><td class="mdescRight">remove a single vertex (by id) from the subgraph  <a href="#a690892609f9fe96c720b12364b522f05">More...</a><br /></td></tr>
<tr class="separator:a690892609f9fe96c720b12364b522f05"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afc262ca800b31471c6dac28bc59e7dd7"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#afc262ca800b31471c6dac28bc59e7dd7">addOutEdge</a> (ID_TYPE src, ID_TYPE target)</td></tr>
<tr class="memdesc:afc262ca800b31471c6dac28bc59e7dd7"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding a single unweighted edge to the output edge buffer of the source vertex  <a href="#afc262ca800b31471c6dac28bc59e7dd7">More...</a><br /></td></tr>
<tr class="separator:afc262ca800b31471c6dac28bc59e7dd7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a63636556c966a8048e7e9e1cb2e91cc7"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a63636556c966a8048e7e9e1cb2e91cc7">addOutEdge</a> (ID_TYPE src, EDGE_TYPE edge)</td></tr>
<tr class="memdesc:a63636556c966a8048e7e9e1cb2e91cc7"><td class="mdescLeft">&#160;</td><td class="mdescRight">(overloaded function) adding a single edge to the output edge buffer of the source vertex  <a href="#a63636556c966a8048e7e9e1cb2e91cc7">More...</a><br /></td></tr>
<tr class="separator:a63636556c966a8048e7e9e1cb2e91cc7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1a2a0614c77bb456f4d0cb504fb114bf"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a1a2a0614c77bb456f4d0cb504fb114bf">addInEdge</a> (ID_TYPE src, ID_TYPE target)</td></tr>
<tr class="memdesc:a1a2a0614c77bb456f4d0cb504fb114bf"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding a single edge to the input edge buffer (if exists) of the target vertex  <a href="#a1a2a0614c77bb456f4d0cb504fb114bf">More...</a><br /></td></tr>
<tr class="separator:a1a2a0614c77bb456f4d0cb504fb114bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8415be2d044f3ccf9fd43f7ca6c092b9"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a8415be2d044f3ccf9fd43f7ca6c092b9">addInEdge</a> (ID_TYPE target, EDGE_TYPE edge)</td></tr>
<tr class="memdesc:a8415be2d044f3ccf9fd43f7ca6c092b9"><td class="mdescLeft">&#160;</td><td class="mdescRight">(overloaded function) adding a single edge to the input edge buffer of the target vertex  <a href="#a8415be2d044f3ccf9fd43f7ca6c092b9">More...</a><br /></td></tr>
<tr class="separator:a8415be2d044f3ccf9fd43f7ca6c092b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbb3850db815aa58de00acbc900ac3e6"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#acbb3850db815aa58de00acbc900ac3e6">removeOutEdge</a> (ID_TYPE src, ID_TYPE target)</td></tr>
<tr class="memdesc:acbb3850db815aa58de00acbc900ac3e6"><td class="mdescLeft">&#160;</td><td class="mdescRight">removing a single edge from the output edge buffer of the source vertex  <a href="#acbb3850db815aa58de00acbc900ac3e6">More...</a><br /></td></tr>
<tr class="separator:acbb3850db815aa58de00acbc900ac3e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0fe9197bac7604394e0f743b993d6ec3"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a0fe9197bac7604394e0f743b993d6ec3">removeInEdge</a> (ID_TYPE src, ID_TYPE target)</td></tr>
<tr class="memdesc:a0fe9197bac7604394e0f743b993d6ec3"><td class="mdescLeft">&#160;</td><td class="mdescRight">removing a single edge from the input edge buffer of the target vertex  <a href="#a0fe9197bac7604394e0f743b993d6ec3">More...</a><br /></td></tr>
<tr class="separator:a0fe9197bac7604394e0f743b993d6ec3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3b6784d2d8eca7c51d78cb98a357025"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad3b6784d2d8eca7c51d78cb98a357025"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#ad3b6784d2d8eca7c51d78cb98a357025">getNumVertices</a> ()</td></tr>
<tr class="memdesc:ad3b6784d2d8eca7c51d78cb98a357025"><td class="mdescLeft">&#160;</td><td class="mdescRight">return the total number of vertices in the subgraph <br /></td></tr>
<tr class="separator:ad3b6784d2d8eca7c51d78cb98a357025"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f6fcbd0cb13652cf2cfb772203cf989"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0f6fcbd0cb13652cf2cfb772203cf989"></a>
ID_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a0f6fcbd0cb13652cf2cfb772203cf989">getNumEdges</a> ()</td></tr>
<tr class="memdesc:a0f6fcbd0cb13652cf2cfb772203cf989"><td class="mdescLeft">&#160;</td><td class="mdescRight">return the total number of edges of local vertices <br /></td></tr>
<tr class="separator:a0f6fcbd0cb13652cf2cfb772203cf989"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a17f052aaccc16b6a9a3c42b4519fe967"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a17f052aaccc16b6a9a3c42b4519fe967"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a17f052aaccc16b6a9a3c42b4519fe967">getVertex</a> (ID_TYPE &amp;id, VERTEX_ITERATOR *it)</td></tr>
<tr class="memdesc:a17f052aaccc16b6a9a3c42b4519fe967"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns an iterator to a vertex from its id <br /></td></tr>
<tr class="separator:a17f052aaccc16b6a9a3c42b4519fe967"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af50bce5a84d6a774a0d0cfed10275eb5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af50bce5a84d6a774a0d0cfed10275eb5"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#af50bce5a84d6a774a0d0cfed10275eb5">getVertexPos</a> (ID_TYPE &amp;id)</td></tr>
<tr class="memdesc:af50bce5a84d6a774a0d0cfed10275eb5"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the position of the vertex in the vertex list from its id <br /></td></tr>
<tr class="separator:af50bce5a84d6a774a0d0cfed10275eb5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a00c57c1eb46c5f6ea4c5c098865c6d11"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a00c57c1eb46c5f6ea4c5c098865c6d11"></a>
VERTEX_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a00c57c1eb46c5f6ea4c5c098865c6d11">getIndexedVertex</a> (ID_TYPE index)</td></tr>
<tr class="memdesc:a00c57c1eb46c5f6ea4c5c098865c6d11"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns an iterator to a vertex from its position <br /></td></tr>
<tr class="separator:a00c57c1eb46c5f6ea4c5c098865c6d11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a84db93d0ec9cfa38e310ddf714aebf2d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a84db93d0ec9cfa38e310ddf714aebf2d"></a>
VERTEX_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a84db93d0ec9cfa38e310ddf714aebf2d">begin</a> ()</td></tr>
<tr class="memdesc:a84db93d0ec9cfa38e310ddf714aebf2d"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the start iterator of the vertex list <br /></td></tr>
<tr class="separator:a84db93d0ec9cfa38e310ddf714aebf2d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9c1703b90d9743de8ab2b6ddb7b0e219"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9c1703b90d9743de8ab2b6ddb7b0e219"></a>
VERTEX_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a9c1703b90d9743de8ab2b6ddb7b0e219">end</a> ()</td></tr>
<tr class="memdesc:a9c1703b90d9743de8ab2b6ddb7b0e219"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the end iterator of the vertex list <br /></td></tr>
<tr class="separator:a9c1703b90d9743de8ab2b6ddb7b0e219"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab310cf3b05179defbdafde49c7167694"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab310cf3b05179defbdafde49c7167694"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#ab310cf3b05179defbdafde49c7167694">size</a> ()</td></tr>
<tr class="memdesc:ab310cf3b05179defbdafde49c7167694"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the local number of vertices <br /></td></tr>
<tr class="separator:ab310cf3b05179defbdafde49c7167694"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af945f921a69f60d84ec83362bed164b4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af945f921a69f60d84ec83362bed164b4"></a>
VERTEX_LIST_PTR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#af945f921a69f60d84ec83362bed164b4">getVerticesPtr</a> ()</td></tr>
<tr class="memdesc:af945f921a69f60d84ec83362bed164b4"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns a pointer to the vertex list <br /></td></tr>
<tr class="separator:af945f921a69f60d84ec83362bed164b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f9e3b506fe87f6393961e551aceb097"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a6f9e3b506fe87f6393961e551aceb097">isConnected</a> (ID_TYPE &amp;src, ID_TYPE &amp;target)</td></tr>
<tr class="memdesc:a6f9e3b506fe87f6393961e551aceb097"><td class="mdescLeft">&#160;</td><td class="mdescRight">check whether two vertices are connected  <a href="#a6f9e3b506fe87f6393961e551aceb097">More...</a><br /></td></tr>
<tr class="separator:a6f9e3b506fe87f6393961e551aceb097"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac15233878a0a6b1bebb89c44019b5868"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac15233878a0a6b1bebb89c44019b5868"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#ac15233878a0a6b1bebb89c44019b5868">isDirected</a> ()</td></tr>
<tr class="memdesc:ac15233878a0a6b1bebb89c44019b5868"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns true if the graph is directed, false otherwise <br /></td></tr>
<tr class="separator:ac15233878a0a6b1bebb89c44019b5868"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a297661a428c71bf40cbfa3b77ec413b0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a297661a428c71bf40cbfa3b77ec413b0"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a297661a428c71bf40cbfa3b77ec413b0">memoryUsage</a> ()</td></tr>
<tr class="memdesc:a297661a428c71bf40cbfa3b77ec413b0"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the approximate overall memory usage of the graph in MB <br /></td></tr>
<tr class="separator:a297661a428c71bf40cbfa3b77ec413b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8157c38da8edf78a26ef6363103ce740"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8157c38da8edf78a26ef6363103ce740"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a8157c38da8edf78a26ef6363103ce740">memory_usage</a> (uint_fast32_t &amp;sizeVerticesList, uint_fast32_t &amp;sizePos)</td></tr>
<tr class="memdesc:a8157c38da8edf78a26ef6363103ce740"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the detailed memory usage for the vertices and position buffers <br /></td></tr>
<tr class="separator:a8157c38da8edf78a26ef6363103ce740"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8503b2b278cb03c8c853df1430d44a0c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8503b2b278cb03c8c853df1430d44a0c"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a8503b2b278cb03c8c853df1430d44a0c">MaxCollision</a> ()</td></tr>
<tr class="memdesc:a8503b2b278cb03c8c853df1430d44a0c"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the maximum collision in the hash table of the position <br /></td></tr>
<tr class="separator:a8503b2b278cb03c8c853df1430d44a0c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a8958238066c83e2bdc2df022edc57586"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8958238066c83e2bdc2df022edc57586"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a8958238066c83e2bdc2df022edc57586">DeallocPosTable</a> ()</td></tr>
<tr class="memdesc:a8958238066c83e2bdc2df022edc57586"><td class="mdescLeft">&#160;</td><td class="mdescRight">deallocate the position list <br /></td></tr>
<tr class="separator:a8958238066c83e2bdc2df022edc57586"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a184cedd204893f3f3ce9faec5c4af387"><td class="memItemLeft" align="right" valign="top">ID_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a184cedd204893f3f3ce9faec5c4af387">hash</a> (ID_TYPE &amp;id)</td></tr>
<tr class="memdesc:a184cedd204893f3f3ce9faec5c4af387"><td class="mdescLeft">&#160;</td><td class="mdescRight">get teh hashed position of a given id  <a href="#a184cedd204893f3f3ce9faec5c4af387">More...</a><br /></td></tr>
<tr class="separator:a184cedd204893f3f3ce9faec5c4af387"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a0cddad22deb3397c932ea4a87fe758a6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0cddad22deb3397c932ea4a87fe758a6"></a>
VERTEX_LIST_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a0cddad22deb3397c932ea4a87fe758a6">vertexList</a></td></tr>
<tr class="memdesc:a0cddad22deb3397c932ea4a87fe758a6"><td class="mdescLeft">&#160;</td><td class="mdescRight">vertexList: holds the physical storage of the subgraph <br /></td></tr>
<tr class="separator:a0cddad22deb3397c932ea4a87fe758a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1be4af9cd97cca92f16ff2ed3ba7c41a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1be4af9cd97cca92f16ff2ed3ba7c41a"></a>
POS_LIST_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a1be4af9cd97cca92f16ff2ed3ba7c41a">vertexPos</a></td></tr>
<tr class="memdesc:a1be4af9cd97cca92f16ff2ed3ba7c41a"><td class="mdescLeft">&#160;</td><td class="mdescRight">vertexPos: holds the position of each vertex in the adjacancy list <br /></td></tr>
<tr class="separator:a1be4af9cd97cca92f16ff2ed3ba7c41a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb9bf5a1f1e563415fc2685a8e770097"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afb9bf5a1f1e563415fc2685a8e770097"></a>
vector&lt; uint_fast32_t &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#afb9bf5a1f1e563415fc2685a8e770097">posHoles</a></td></tr>
<tr class="memdesc:afb9bf5a1f1e563415fc2685a8e770097"><td class="mdescLeft">&#160;</td><td class="mdescRight">posHoles: holes in the vertex list that should be exploited first in adding vertex <br /></td></tr>
<tr class="separator:afb9bf5a1f1e563415fc2685a8e770097"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8f8279b68201a061a0b82d6baa8efea9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8f8279b68201a061a0b82d6baa8efea9"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a8f8279b68201a061a0b82d6baa8efea9">flagDirected</a></td></tr>
<tr class="memdesc:a8f8279b68201a061a0b82d6baa8efea9"><td class="mdescLeft">&#160;</td><td class="mdescRight">flagDirected: true if directed graph, false if undirected graph <br /></td></tr>
<tr class="separator:a8f8279b68201a061a0b82d6baa8efea9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3052785c9de1b497dfeb3df1f3908318"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3052785c9de1b497dfeb3df1f3908318"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSubgraphBase.html#a3052785c9de1b497dfeb3df1f3908318">posHashSize</a></td></tr>
<tr class="memdesc:a3052785c9de1b497dfeb3df1f3908318"><td class="mdescLeft">&#160;</td><td class="mdescRight">the size of the position hash table <br /></td></tr>
<tr class="separator:a3052785c9de1b497dfeb3df1f3908318"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename CVertex&gt;<br />
class TIGLContainersSubgraphBase&lt; CVertex &gt;</h3>

<p>core data container for a subgraph in each device. </p>
<p>It contains the vertex list and the corresponding hashed position buffer. It also handles all graph mutations. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a9a38e2aef24edfb18f95685e88441c15"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::<a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isDireted</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>assignedHashSize</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>constructor of <a class="el" href="classSubgraphBase.html" title="core data container for a subgraph in each device. ">TIGLContainersSubgraphBase</a> </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">isDireted</td><td>true if directed graph, false if undirected graph </td></tr>
    <tr><td class="paramname">assignedHashSize</td><td>hash size of the position list (set to the default value if unassigned) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a401d397bc80d0c0606056ab1ff00e1ef"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::<a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a> </td>
          <td>(</td>
          <td class="paramtype">VERTEX_LIST_TYPE &amp;&#160;</td>
          <td class="paramname"><em>init_adj_list</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isDireted</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>assignedHashSize</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>overloaded constructor of <a class="el" href="classSubgraphBase.html" title="core data container for a subgraph in each device. ">TIGLContainersSubgraphBase</a> </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">init_adj_list</td><td>the initial adjacent list of the subgraph (in the form of vector of vertices) </td></tr>
    <tr><td class="paramname">isDireted</td><td>true if directed graph, false if undirected graph </td></tr>
    <tr><td class="paramname">assignedHashSize</td><td>hash size of the position list (set to the default value if unassigned) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a1a2a0614c77bb456f4d0cb504fb114bf"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::addInEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adding a single edge to the input edge buffer (if exists) of the target vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">target</td><td>destination vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if either vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="a8415be2d044f3ccf9fd43f7ca6c092b9"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::addInEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">EDGE_TYPE&#160;</td>
          <td class="paramname"><em>edge</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>(overloaded function) adding a single edge to the input edge buffer of the target vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">target</td><td>destination vertx vertex </td></tr>
    <tr><td class="paramname">edge</td><td>edge object </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if either vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="afc262ca800b31471c6dac28bc59e7dd7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::addOutEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adding a single unweighted edge to the output edge buffer of the source vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">target</td><td>destination vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if either vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="a63636556c966a8048e7e9e1cb2e91cc7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::addOutEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">EDGE_TYPE&#160;</td>
          <td class="paramname"><em>edge</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>(overloaded function) adding a single edge to the output edge buffer of the source vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">edge</td><td>edge object </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if either vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="a7f84979500a707a643c5bd1638ec6f67"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::addVertex </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classVertexBase.html">CVertex</a> &amp;&#160;</td>
          <td class="paramname"><em>x</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adding a single vertex to the vertex list </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>the new vertex (by reference) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aafd0e90c37dae7b49cbdc612362df8d0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::addVertex </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adding an empty vertex (by id) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>vertex id </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1a8f8c5aebe53cfa75a0da8ceeb13c73"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::addVertex_consistent </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classVertexBase.html">CVertex</a> &amp;&#160;</td>
          <td class="paramname"><em>x</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>adding a single vertex after checking its existence </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>the new vertex (by reference) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the vertex is added propoerly, false if it already exists </dd></dl>

</div>
</div>
<a class="anchor" id="af1d321bddac759f440f3292081b89a82"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::createVerticesList </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>numVertices</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>creating vertex list with trivial vertices </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">numVertices</td><td>total number of vertices in the list </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5ded8c3cbfaa063fdf16cb25ab2b0399"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::exist </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>check the existence of a vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>the vertex id </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the vertex exists in the local subgraph, otherwise false </dd></dl>

</div>
</div>
<a class="anchor" id="ad588a2ada1c05c5a91f8127a5cb7e700"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::findPos </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t &amp;&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>finding the position of a given vertex (from its id) </p>
<p>For core graph algorithms the performance of this function is critical </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td><a class="el" href="classTIGLApiVertex.html" title="core vertex class for the TIGL Engine (with only output edge buffer). ">TIGLApiVertex</a> id </td></tr>
    <tr><td class="paramname">pos</td><td>a reference in which the position is written </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the vertex exist, false if the vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="a184cedd204893f3f3ce9faec5c4af387"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::ID_TYPE <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::hash </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>get teh hashed position of a given id </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>the id of the requested vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the hashed position of the vertex </dd></dl>

</div>
</div>
<a class="anchor" id="a6f9e3b506fe87f6393961e551aceb097"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::isConnected </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>check whether two vertices are connected </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">target</td><td>destination vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if connected, false if not connected </dd></dl>

</div>
</div>
<a class="anchor" id="a0fe9197bac7604394e0f743b993d6ec3"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::removeInEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>removing a single edge from the input edge buffer of the target vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">target</td><td>destination vertx vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if the edge does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="acbb3850db815aa58de00acbc900ac3e6"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::removeOutEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>removing a single edge from the output edge buffer of the source vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source vertex </td></tr>
    <tr><td class="paramname">target</td><td>destination vertx vertex </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if the edge or the vertex does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="a690892609f9fe96c720b12364b522f05"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt; <a class="el" href="classVertexBase.html">CVertex</a> &gt;::removeVertex </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>remove a single vertex (by id) from the subgraph </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>vertex id </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if the vertex does not exist </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/home/mohamed/code/tigl/src/common/containers/<a class="el" href="tiglContainersSubgraphBase_8hpp_source.html">tiglContainersSubgraphBase.hpp</a></li>
<li>/home/mohamed/code/tigl/src/common/containers/<a class="el" href="tiglContainersSubgraphBaseImplementation_8hpp_source.html">tiglContainersSubgraphBaseImplementation.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Mar 3 2015 18:17:03 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
